% BSD 2-Clause License

% Copyright (c) 2022, Armin Nurkanović, Jonathan Frey, Anton Pozharskiy, Moritz Diehl

% Redistribution and use in source and binary forms, with or without
% modification, are permitted provided that the following conditions are met:

% 1. Redistributions of source code must retain the above copyright notice, this
%    list of conditions and the following disclaimer.

% 2. Redistributions in binary form must reproduce the above copyright notice,
%    this list of conditions and the following disclaimer in the documentation
%    and/or other materials provided with the distribution.

% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
% AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
% IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
% DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
% FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
% DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
% SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
% CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
% OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
% OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

% This file is part of NOSNOC.

clear all
import casadi.*

switching_case = 'crossing';
% switching_case = 'sliding_mode';
% switching_case = 'spontaneous_switch';

problem_options = NosnocProblemOptions();
model = NosnocModel();

% discretization parameters
%problem_options.T_sim = TODO
problem_options.N_sim = 7;
problem_options.N_finite_elements = 2;
problem_options.n_s = 2;
problem_options.irk_scheme = IRKSchemes.GAUSS_LEGENDRE;
problem_options.irk_representation= 'differential';

switch switching_case
    case 'crossing'
        error("TODO: implement Filippov system")
        x = SX.sym('x',1);
        % model.x0 =
        % model.x =
        % model.c =
        % model.S =
        % model.F = [f_1 f_2];
    case 'sliding_mode'
        %
        error("TODO: exercise 2.4")
    case 'spontaneous_switch'
        %
        error("TODO: BONUS exercise")
    otherwise
        error('...')
end

solver_options = NosnocSolverOptions();
solver_options.print_level = 3;
solver_options.store_integrator_step_results = 1;


if strcmp('spontaneous_switch', switching_case)
    % initialize solver
    % TODO: for Bonus exercise..
    % theta_init = ...
    % integrator.solver.set('theta', theta_init);
end

integrator = NosnocIntegrator(model, problem_options, solver_options, [], []);
[results,stats] = integrator.solve();

% plot
figure
latexify_plot()
plot(results.t_grid,results.x(1,:))
grid on
xlabel('$t$')
ylabel('$x(t)$')
grid on

